flash unsigned int tabz[] =  {32,64,128,256,512,1024,2048};

flash unsigned int tabkd[] = {0,4748,4480,4228,3992,3768,3556,3356,3168,2990,2822,
        2664,2514,2374,2240,2114,1996,1884,1778,1678,1584,1495,1411,1332,1257,
        1187,1120,1057, 998,942,889,839,792};

flash unsigned char mel1[] = {120,110,120,110,120,120,110,110,108,108,110,255};

flash unsigned char mel_start[] = {150,150,120,110,120,120,110,150,255};

flash unsigned char mel911[] = {140,138,139,255}; 

unsigned char fnota;  
unsigned char dnota;    
flash unsigned char *nota;  


unsigned char flz;   

interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{flz=1;}
     
interrupt [TIM1_COMPA] void timer1_compa_isr(void)
{flz=1;}

void wait (unsigned char kodz)
{
   if (kodz==1) TIMSK=0x40;
   else TIMSK=0x80;
   TCNT1=0;   
   flz=0;     
   #asm("sei"); 
   if (kodz!=2) while(flz==0); 
}

void start (void)
{
      TCCR1B=0x09; 
m3:   nota = mel_start;      
m4:   if (*nota==0xFF) goto m2;  
      fnota = (*nota)&0x1F;         
      dnota = ((*nota)>>5)&0x07;  
      if (fnota==0) goto m5;       
      OCR1A=tabkd[fnota];          
      TCCR1A=0x40;                 
m5:   delay_ms (tabz[dnota]);       
      TCCR1A=0x00;               
      delay_ms (tabz[0]);        
      nota++;                     
      goto m4;                     
m2:   TCCR1A=0x00;
}

 void zwuk (void)
{   
      TCCR1B=0x09;
m3:   nota = mel1;
m4:   if (*nota==0xFF) goto m2;     
      fnota = (*nota)&0x1F;        
      dnota = ((*nota)>>5)&0x07;    
      if (fnota==0) goto m5;       
      OCR1A=tabkd[fnota];           
      TCCR1A=0x40;                  
m5:   delay_ms (tabz[dnota]);       
      TCCR1A=0x00;                  
      delay_ms (tabz[0]);           
      nota++;                       
      goto m4;                      
m2:   TCCR1A=0x00;                 
}   

 void ohran_prowod (void)
{
      TCCR1B=0x09;
m3:   nota = mel911;          
m4:  if (PIND.2==0) { goto m2;}       
      if (*nota==0xFF) goto m6; 
      fnota = (*nota)&0x1F;       
      dnota = ((*nota)>>5)&0x07;    
      if (fnota==0) goto m5;       
      OCR1A=tabkd[fnota];          
      TCCR1A=0x40;            
m5:   delay_ms (tabz[dnota]);     
      TCCR1A=0x00;               
      delay_ms (tabz[0]);         
      nota++;                   
      goto m4;                     
m2:   TCCR1A=0x00; 
m6:   TCCR1A=0x00;
      if (PIND.2!=0) goto m3;
}  

 void rab_temp (void) 
{    TCCR1B=0x09; 
m3:   nota = mel911;         
m4:   if (PIND.2==0) { goto m2;}       
      if (*nota==0xFF) goto m6;    
      fnota = (*nota)&0x1F;         
      dnota = ((*nota)>>5)&0x07;    
      if (fnota==0) goto m5;       
      OCR1A=tabkd[fnota];           
      TCCR1A=0x40;                  
m5:   delay_ms (tabz[dnota]);      
      TCCR1A=0x00;               
      delay_ms (tabz[0]);          
      nota++;                
      goto m4;                   
m2:   TCCR1A=0x00;               
m6:   TCCR1A=0x00;
}  
